VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Calculate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Const mcstrMult As String = "*"
Private Const mcstrDiv As String = "/"
Private Const mcstrMod As String = "%"
Private Const mcstrPower As String = "^"
Private Const mcstrAdd As String = "+"
Private Const mcstrSub As String = "-"
Private Const mcstrLParen As String = "("
Private Const mcstrRParen As String = ")"
Private Const mcstrUnaryMinus As String = "-"
Private Const mcstrUnaryPlus As String = "+"
Private Const mcstrSin As String = "sin"
Private Const mcstrCos As String = "cos"
Private Const mcstrTan As String = "tan"
Private Const mcstrAtan As String = "atn"
Private Const mcstrExp As String = "exp"
Private Const mcstrLog As String = "log"
Private Const mcstrPi As String = "pi"
Private Const mcstrE As String = "e"
Private Const mcdblPi As Double = 3.14159265358979
Private Const mcdblE As Double = 2.718282
Private m_strExpression As String
Private m_strPostfix As String
Private mfNegateParenOps As Boolean
Private mstrToken As String
Private mstrSeparatorUsed As String
Private Enum tokTokenState
tokWhiteSpace
tokToken
tokUndefined
End Enum
Private Enum tokCharType
tokWhiteSpaceChar
tokSeparatorChar
tokTokenChar
End Enum
Private mstrWhiteSpaceChars As String
Private mstrSeparatorChars As String
Private meState As tokTokenState
Private mstrCurrentChar As String
Private mstrInternalToken As String
Private mlngLen As Double
Private mlngPos As Double
Private mstrTokenText As String
Private mavarData() As Variant
Private mintTop As Double
Private Const mcdblSizeStack As Double = 200
Private Sub Class_Initialize()
On Error GoTo PROC_ERR
ReDim mavarData(mcdblSizeStack)
mintTop = 0
PROC_EXIT:
Exit Sub
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Sub
Public Property Get Expression() As String
Expression = m_strExpression
End Property
Public Property Let Expression(ByVal strValue As String)
m_strExpression = strValue
ConvertToPostfix
End Property
Public Property Get Postfix() As String
Postfix = m_strPostfix
End Property
Public Function Evaluate() As Double
Dim dblNumber1 As Double
Dim dblNumber2 As Double
Dim dblResult As Double
Dim strToken As String
Dim fUnaryMinus As Boolean
On Error GoTo PROC_ERR
mstrSeparatorChars = vbNullString
SetTokenString m_strPostfix
 Do While GetNextToken(strToken, mstrSeparatorUsed)
If strToken = mcstrMult Or strToken = mcstrAdd Or strToken = mcstrDiv Or strToken = mcstrSub Or strToken = mcstrPower Or strToken = mcstrMod Then
PopResult dblNumber2
PopResult dblNumber1
Select Case strToken
Case mcstrAdd
dblResult = dblNumber1 + dblNumber2
Case mcstrMult
dblResult = dblNumber1 * dblNumber2
Case mcstrDiv
dblResult = dblNumber1 / dblNumber2
Case mcstrSub
dblResult = dblNumber1 - dblNumber2
Case mcstrPower
dblResult = dblNumber1 ^ dblNumber2
Case mcstrMod
dblResult = dblNumber1 Mod dblNumber2
End Select
PushResult dblResult
Else
If Mid$(strToken, 1, 1) = mcstrUnaryMinus Then
fUnaryMinus = True
strToken = Right$(strToken, Len(strToken) - 1)
Else
fUnaryMinus = False
End If
If strToken = mcstrSin Or strToken = mcstrCos Or strToken = mcstrTan Or strToken = mcstrAtan Or strToken = mcstrExp Or strToken = mcstrLog Then
PopResult dblNumber1
Select Case strToken
Case mcstrSin
dblResult = Sin(dblNumber1)
Case mcstrCos
dblResult = Cos(dblNumber1)
Case mcstrTan
dblResult = Tan(dblNumber1)
Case mcstrAtan
dblResult = Atn(dblNumber1)
Case mcstrExp
dblResult = Exp(dblNumber1)
Case mcstrLog
dblResult = Log(dblNumber1)
End Select
If fUnaryMinus Then
dblResult = -dblResult
End If
PushResult dblResult
ElseIf strToken = mcstrPi Or strToken = mcstrE Then
Select Case strToken
Case mcstrPi
dblResult = mcdblPi
Case mcstrE
dblResult = mcdblE
End Select
PushResult dblResult
Else
dblResult = strToken
If fUnaryMinus Then
dblResult = -dblResult
End If
PushResult dblResult
End If
End If
Loop
PopResult dblNumber1
Evaluate = dblNumber1
PROC_EXIT:
Exit Function
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Function
Private Function CharType() As tokCharType
On Error GoTo PROC_ERR
If InStr(mstrSeparatorChars, mstrCurrentChar) > 0 Then
CharType = tokSeparatorChar
ElseIf InStr(mstrWhiteSpaceChars, mstrCurrentChar) > 0 Then
CharType = tokWhiteSpaceChar
Else
CharType = tokTokenChar
End If
PROC_EXIT:
Exit Function
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Function
Private Sub ConvertToPostfix()
Dim strToken As String
Dim strSeparatorUsed As String
Dim strNewExpression As String
On Error GoTo PROC_ERR
mstrSeparatorChars = "*/+-%^()"
mstrWhiteSpaceChars = " "
SetTokenString m_strExpression
Do While GetNextToken(strToken, strSeparatorUsed)
If strToken <> vbNullString Then
strNewExpression = strNewExpression & strToken & " "
End If
If strSeparatorUsed <> vbNullString Then
strNewExpression = strNewExpression & strSeparatorUsed & " "
End If
Loop
mstrSeparatorChars = ""
SetTokenString strNewExpression
GetNextToken mstrToken, mstrSeparatorUsed
ParseExpression
PROC_EXIT:
Exit Sub
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Sub
Private Function GetNextToken(strToken As String, strSeparatorUsed As String) As Boolean
Dim fContinue As Boolean
On Error GoTo PROC_ERR
mstrInternalToken = vbNullString
strSeparatorUsed = vbNullString
meState = tokWhiteSpace
fContinue = True
GetNextToken = True
If mlngPos > mlngLen Then
GetNextToken = False
fContinue = False
End If
Do While mlngPos <= mlngLen And fContinue = True
mstrCurrentChar = Mid$(mstrTokenText, mlngPos, 1)
Select Case CharType
Case tokSeparatorChar
fContinue = HandleSeparator(strSeparatorUsed)
Case tokWhiteSpaceChar
fContinue = HandleWhiteSpace
Case Else
fContinue = HandleToken
End Select
Loop
strToken = mstrInternalToken
PROC_EXIT:
Exit Function
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Function
Private Function HandleSeparator(strSeparatorUsed As String) As Boolean
On Error GoTo PROC_ERR
mlngPos = mlngPos + 1
strSeparatorUsed = mstrCurrentChar
HandleSeparator = False
PROC_EXIT:
Exit Function
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Function
Private Function HandleToken() As Boolean
On Error GoTo PROC_ERR
HandleToken = True
Select Case (meState)
Case tokWhiteSpace
meState = tokToken
mstrInternalToken = mstrInternalToken & LCase(mstrCurrentChar)
mlngPos = mlngPos + 1
Case tokToken
mstrInternalToken = mstrInternalToken & LCase(mstrCurrentChar)
mlngPos = mlngPos + 1
Case tokUndefined
HandleToken = False
End Select
PROC_EXIT:
Exit Function
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Function
Private Function HandleWhiteSpace() As Boolean
On Error GoTo PROC_ERR
HandleWhiteSpace = True
Select Case (meState)
Case tokWhiteSpace, tokUndefined
mlngPos = mlngPos + 1
Case tokToken
meState = tokUndefined
mlngPos = mlngPos + 1
End Select
PROC_EXIT:
Exit Function
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Function
Private Sub ParseExpression()
Dim strToken As String
On Error GoTo PROC_ERR
ParseTerm
Do While mstrToken = mcstrAdd Or mstrToken = mcstrSub
strToken = mstrToken
GetNextToken mstrToken, mstrSeparatorUsed
ParseTerm
m_strPostfix = m_strPostfix & strToken & " "
Loop
PROC_EXIT:
Exit Sub
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Sub
Private Sub ParseFactor()
Dim strToken As String
Dim fUnaryMinus As Boolean
On Error GoTo PROC_ERR
If mstrToken = mcstrUnaryMinus Or mstrToken = mcstrUnaryPlus Then
If mstrToken = mcstrUnaryMinus Then
fUnaryMinus = True
End If
GetNextToken mstrToken, mstrSeparatorUsed
End If
If mfNegateParenOps Then
fUnaryMinus = Not fUnaryMinus
End If
If mstrToken = mcstrLParen Then
If fUnaryMinus Then
mfNegateParenOps = True
End If
GetNextToken mstrToken, mstrSeparatorUsed
ParseExpression
If mstrToken = mcstrRParen Then
GetNextToken mstrToken, mstrSeparatorUsed
mfNegateParenOps = False
End If
Else
If mstrToken = mcstrSin Or mstrToken = mcstrCos Or mstrToken = mcstrTan Or mstrToken = mcstrAtan Or mstrToken = mcstrExp Or mstrToken = mcstrLog Then
strToken = mstrToken
GetNextToken mstrToken, mstrSeparatorUsed
ParseFactor
If fUnaryMinus Then
m_strPostfix = m_strPostfix & mcstrUnaryMinus & strToken & " "
Else
m_strPostfix = m_strPostfix & strToken & " "
End If
Else
If fUnaryMinus Then
m_strPostfix = m_strPostfix & mcstrUnaryMinus & mstrToken & " "
Else
m_strPostfix = m_strPostfix & mstrToken & " "
End If
GetNextToken mstrToken, mstrSeparatorUsed
End If
End If
PROC_EXIT:
Exit Sub
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Sub
Private Sub ParseTerm()
Dim strToken As String
On Error GoTo PROC_ERR
ParseFactor
Do While mstrToken = mcstrMult Or mstrToken = mcstrDiv Or mstrToken = mcstrMod Or mstrToken = mcstrPower
strToken = mstrToken
GetNextToken mstrToken, mstrSeparatorUsed
ParseFactor
m_strPostfix = m_strPostfix & strToken & " "
Loop
PROC_EXIT:
Exit Sub
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Sub
Private Function PopResult(varData As Double) As Boolean
On Error GoTo PROC_ERR
If mintTop > 0 Then
mintTop = mintTop - 1
varData = mavarData(mintTop)
PopResult = True
Else
PopResult = False
varData = 0
End If
PROC_EXIT:
Exit Function
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Function
Private Sub PushResult(varData As Double)
On Error GoTo PROC_ERR
mavarData(mintTop) = varData
mintTop = mintTop + 1
PROC_EXIT:
Exit Sub
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Sub
Private Sub SetTokenString(strTokenText As String)
On Error GoTo PROC_ERR
mstrTokenText = strTokenText
mlngPos = 1
mlngLen = Len(strTokenText)
PROC_EXIT:
Exit Sub
PROC_ERR:
MsgBox " " & Err.Number & "  -  " & Err.Description & "!", 48, "!"
ErrorH ("Error")
Resume PROC_EXIT
End Sub
